/*
Name: MESHAL ALI OKAIRY
Email: mokairy@stu.kau.edu.sa
ID: 2237836
Section: F12
*/

package mainprogram;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class MainProgram {

    public static void main(String[] args) throws FileNotFoundException {
        File f1 = new File("intialInformation.txt");
        if (!f1.exists()) {
            System.out.println("Could NOT Find intialInformation.txt");
            System.exit(0);
        }
        Scanner input = new Scanner(f1);
        File f2 = new File("Commands.txt");
        if (!f2.exists()) {
            System.out.println("Could NOT Find commands.txt");
            System.exit(0);
        }
        Scanner commands = new Scanner(f2);
        
        File f3 = new File("output.txt");
        PrintWriter output = new PrintWriter(f3);

        

        
        int insNum = input.nextInt();
        int classes = input.nextInt();
        int coordNum = input.nextInt();
        boolean EachCourseMSG = true;
        boolean InstructorInfoMSG = true;
        boolean SwapMSG = true;
        boolean DeleteMSG = true;

        Instructor[] instructor = new Instructor[insNum];
        Course[] courses = new Course[classes];
        int[] coordinators = new int[coordNum];

        output.println("\t\t\t\t\t\tWelcome to Course Coordination System\n"
                + "\t\t\t\t\t-----------------------------------------------------");
        String command = commands.next();

        do {
            if (command.equalsIgnoreCase("STARTUP")) {

                for (int i = 0; i < courses.length; i++) {
                    int n = Integer.parseInt(input.next().substring(4));
                    courses[i] = new Course(n);

                }
                for (int i = 0; i < coordinators.length; i++) {
                    coordinators[i] = input.nextInt();
                }

                for (int i = 0; i < courses.length; i++) {
                    for (int j = 0; j < insNum / classes; j++) {
                        courses[i].addInstructor(input.nextInt(), input.next(), input.next());

                    }

                }
                for (int i = 0; i < courses.length; i++) {
                    for (int j = 0; j < insNum / classes; j++) {
                        courses[i].setCoord(coordinators[i]);

                    }
                }

                for (int i = 0; i < courses.length; i++) {
                    int n = Integer.parseInt(input.next().substring(4));
                    for (int j = 0; j < courses.length; j++) {
                        if (courses[j].getCourseNumber() == n) {
                            courses[j].setCourseName(input.nextLine());
                            break;
                        }

                    }

                }

            } else if (command.equalsIgnoreCase("DISPLAY_ALL_COURSES")) {
                output.printf("%57s ", "Information of Instructors in Each Class\n");
                for (int i = 0; i < courses.length; i++) {
                    output.printf("%n %50s %n%n", "Instructors in CPCS" + courses[i].getCourseNumber() + " Course");
                    output.printf("\t%-10s %-26s %-25s %n", "ID", "Name", "Coordinator");
                    courses[i].printCourses(output);

                }

            } else if (command.equalsIgnoreCase("DISPLAY_COURSE_FOR_INSTRUCTOR")) {
                if (InstructorInfoMSG) {
                    output.printf("%30s ", "Instructor Information\n");
                    InstructorInfoMSG = false;
                }

                int ID = commands.nextInt();
                for (int i = 0; i < courses.length; i++) {
                    Instructor found = courses[i].searchInstructorByID(ID);
                    Instructor coordinator = courses[i].coordinatedBy();
                    if (found == null && courses.length - 1 == i) {
                        output.println("\tNo instructor of this ID is found");

                    } else if (found != null) {
                        if (found.getID() < 10) {
                            output.println("\t\"Instructor: " + found.getfName() + " " + found.getlName() + ", 00" + found.getID() + ", is assigned to CPCS" + courses[i].getCourseNumber() + courses[i].getCourseName() + ", coordinated by 00" + coordinator.getID() + " " + coordinator.getfName() + " " + coordinator.getlName() + "\"");

                        } else {
                            output.println("\t\"Instructor: " + found.getfName() + " " + found.getlName() + ",0" + found.getID() + ", is assigned to CPCS" + courses[i].getCourseNumber() + courses[i].getCourseName() + ", coordinated by 0" + coordinator.getID() + " " + coordinator.getfName() + " " + coordinator.getlName() + "\"");
                        }
                        break;

                    }
                }

            } else if (command.equalsIgnoreCase("NUM_OF_INSTRUCTORS")) {
                if (EachCourseMSG) {
                    output.println("\n \tNumber of Instructors in Each Course");
                    EachCourseMSG = false;
                }

                int n = Integer.parseInt(commands.next().substring(4));
                for (int i = 0; i < courses.length; i++) {
                    if (courses[i].getCourseNumber() == n) {
                        output.println("\t Number of Instructors in CPCS" + n + ": " + courses[i].numOfInstructor());

                    }

                }

            } else if (command.equalsIgnoreCase("DELETE_INSTRUCTOR")) {
                if (DeleteMSG) {
                    output.println("\n \tDelete Instructor");
                    DeleteMSG = false;
                }

                int ID = commands.nextInt();

                for (int i = 0; i < courses.length; i++) {
                    Instructor ins = courses[i].searchInstructorByID(ID);

                    if (ins != null && ins.getCootdinator().equalsIgnoreCase("NO")) {
                        courses[i].deleteInstructorByID(ID);
                        output.println("\tCPCS" + courses[i].getCourseNumber() + " is not assigned to " + ins.getfName() + " " + ins.getlName());

                    } else if (ins != null && ins.getCootdinator().equalsIgnoreCase("YES")) {
                        output.println("\tYou Cannot Delete A Coordinator");

                    }

                }

            } else if (command.equalsIgnoreCase("SWAP_INSTRUCTOR")) {
                if (SwapMSG) {
                    output.println("\n\tSwap Instructors");
                    SwapMSG = false;
                }
                int ID1 = commands.nextInt();
                int ID2 = commands.nextInt();
                Instructor ins1 = null, ins2 = null;

                for (int i = 0; i < courses.length; i++) {
                    if (ins1 == null) {
                        ins1 = courses[i].searchInstructorByID(ID1);
                    }
                    if (ins2 == null) {
                        ins2 = courses[i].searchInstructorByID(ID2);
                    }

                }
                if (ins1.isCootdinator() == ins2.isCootdinator()) {
                    String tempfName = ins1.getfName();
                    String templName = ins1.getlName();
                    int tempID = ins1.getID();

                    ins1.setfName(ins2.getfName());
                    ins1.setlName(ins2.getlName());
                    ins1.setID(ins2.getID());

                    ins2.setfName(tempfName);
                    ins2.setlName(templName);
                    ins2.setID(tempID);

                    output.println("\t\"" + ins2.getfName() + " " + ins2.getlName() + " id now in " + ins2.getCourse() + " , " + ins1.getfName() +" "+ ins1.getlName() + " id now in " + ins1.getCourse() + "\"");

                } else if (ins1.isCootdinator()) {
                    output.println("\t\"Coordinator " + ins1.getfName() + " " + ins1.getlName() + " can not be swapped with instructor " + ins2.getfName() + " " + ins2.getlName() + "\"");
                } else if (ins2.isCootdinator()) {
                    output.println("\t\"Coordinator " + ins2.getfName() + " " + ins2.getlName() + " can not be swapped with instructor " + ins1.getfName() + " " + ins1.getlName() + "\"");

                }

            }
            output.println("");
            command = commands.next();
        } while (!command.equalsIgnoreCase("QUIT"));

        
        output.println("\n\t============================\n\t\t Best Wishes\n\t============================");
        input.close();
        commands.close();
        output.flush();
        output.close();
        System.out.println(">\tDone.\n"
                + ">\tYou Can Find The \"" + f3.getName() + "\" File In: \n>\t\"" + f3.getAbsolutePath() + "\"");
        System.out.println(">\t-----------------------------------------------------");
    }

}
