/*
Name: MESHAL ALI OKAIRY
Email: mokairy@stu.kau.edu.sa
ID: 2237836
Section: F12
 */
package Recursion;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;

public class Recursion_Assignment {

    public static void main(String[] args) throws FileNotFoundException {
        File input = new File("input.txt");
        if (!input.exists()) {
            System.out.println("==========================\nThe input File Is Missing.\n==========================");
            System.exit(0);
        }

        Scanner inputSc = new Scanner(input);
        File output = new File("output.txt");
        PrintWriter outputPW = new PrintWriter(output);

        int commandsNum = inputSc.nextInt();

        for (int i = 0; i < commandsNum; i++) {
            String command = inputSc.next();

            if (command.equalsIgnoreCase("repeatDigit")) {
                String M = inputSc.next(), K = inputSc.next();
                int R = inputSc.nextInt();
                int N = repeatDigit(M, K, R);
                outputPW.println(N + " is the number with repeated " + R + " times of digit " + K);

            } else if (command.equalsIgnoreCase("findEvenNumbers")) {
                String[] numbers = inputSc.next().split(",");
                ArrayList evenNum = new ArrayList();

                outputPW.print("The even array list is: ");
                findEvenNumbers(numbers, evenNum, 0);

                for (int j = 0; j < evenNum.size(); j++) {
                    if (j == evenNum.size() - 1) {
                        outputPW.print(evenNum.get(j));
                    } else {
                        outputPW.print(evenNum.get(j) + ",");
                    }
                }
                outputPW.println("");

            } else if (command.equalsIgnoreCase("displayCommonChars")) {
                String str1 = inputSc.next(), str2 = inputSc.next();

                outputPW.print("The common characters are " + getCommonChars(str1, str2));
                outputPW.println("");

            }

        }

        inputSc.close();
        outputPW.flush();
        outputPW.close();
        System.out.println("==========================\n\t   Done.\n==========================");

    }
//==========================================================================================

    public static int repeatDigit(String M, String K, int R) {
        if (R == 0) {
            return Integer.parseInt(M);
        }

        return repeatDigit(M + K, K, --R);
    }
//==========================================================================================

    public static ArrayList findEvenNumbers(String[] numbers, ArrayList evenNum, int i) {

        while (i < numbers.length) {
            int temp = Integer.parseInt(numbers[i]);
            if (temp % 2 == 0) 
                evenNum.add(temp);

            return findEvenNumbers(numbers, evenNum, ++i);
        }

        return evenNum;
    }

//==========================================================================================
    public static String getCommonChars(String str1, String str2) {
        if (str1.isEmpty() || str2.isEmpty()) {
            return "";
        }

        char char1 = str1.charAt(0);
        char char2 = str2.charAt(0);

        if (char1 == Character.toLowerCase(char2) || char1 == Character.toUpperCase(char2)) {

            return char1 + getCommonChars(str1.substring(1), str2.substring(1));
        } else {

            String rest1 = getCommonChars(str1.substring(1), str2);
            String rest2 = getCommonChars(str1, str2.substring(1));
            if (rest1.length() > rest2.length()) {
                return rest1;
            } else {
                return rest2;
            }
        }
    }

}
