/*
Name: MESHAL ALI OKAIRY
Email: mokairy@stu.kau.edu.sa
ID: 2237836
Section: F12
 */
package URLStackSystem;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class WebPages {

    public static void main(String[] args) throws FileNotFoundException {

        File f1 = new File("intialInformationStack.txt");
        if (!f1.exists()) {
            System.out.println("\"" + f1.getName() + "\" Is Messing.");
            System.exit(0);
        }
        Scanner input1 = new Scanner(f1);

        File f2 = new File("CommandsStack.txt");
        if (!f2.exists()) {
            System.out.println("\"" + f2.getName() + "\" Is Messing.");
            System.exit(0);
        }
        Scanner input2 = new Scanner(f2);

        File f3 = new File("OutputStack.txt");
        PrintWriter output = new PrintWriter(f3);

        webPageStackArray T1 = new webPageStackArray(10);
        webPageStackArray T2 = new webPageStackArray(10);
        webPageStackArray T3 = new webPageStackArray(10);
        webPageStackArray History = new webPageStackArray(50);

        output.println("\t\t\t\t\t\t      Welcome to URL Stack System\n"
                + "\t\t\t\t\t-----------------------------------------------------\n\n");

        String command = input2.next();

        do {
            if (command.equalsIgnoreCase("STARTUP")) {
                STARTUP(T1, T2, T3, input1, output);
                output.println("\n------------------------------------------------------------------------\n\n");

            } else if (command.equalsIgnoreCase("GO_FORWARD")) {
                GO_FORWARD(T1, T2, T3, input2, output);
                output.println("------------------------------------------------------------------------");

            } else if (command.equalsIgnoreCase("GO_BACK")) {
                GO_BACK(T1, T2, T3, History, input2, output);

            } else if (command.equalsIgnoreCase("DISPLAY_ALL_VISITED")) {
                output.println("\n");
                DISPLAY_ALL_VISITED(T1, T2, T3, History, output);
                output.println("\n");
            }

            command = input2.next();
        } while (!command.equalsIgnoreCase("QUIT"));
        
        output.println("==========================\n\tBest Wishes\n==========================");
        input1.close();
        input2.close();
        output.flush();
        output.close();
        
    }

    //=====================================================================================\\
    public static void STARTUP(webPageStackArray T1, webPageStackArray T2, webPageStackArray T3, Scanner input1, PrintWriter output) {
        int num = input1.nextInt();
        for (int i = 0; i < num; i++) {
            String tab = input1.next();
            String URL = input1.next();

            switch (tab) {
                case "T1":
                    T1.push(URL);
                    output.println("The URL (" + URL + ") was pushed into Stack T1");
                    break;

                case "T2":
                    T2.push(URL);
                    output.println("The URL (" + URL + ") was pushed into Stack T2");
                    break;

                case "T3":
                    T3.push(URL);
                    output.println("The URL (" + URL + ") was pushed into Stack T3");
                    break;

            }

        }
    }

    //=====================================================================================\\
    public static void GO_FORWARD(webPageStackArray T1, webPageStackArray T2, webPageStackArray T3, Scanner input2, PrintWriter output) {
        String tab = input2.next();
        String URL = input2.next();

        switch (tab) {
            case "T1":
                if (!T1.isFull()) {
                    T1.push(URL);
                    output.println("The URL (" + URL + ") was pushed into Stack T1");
                    break;
                } else {
                    output.println("The T1 stack is full, the following URL (" + URL + ") cannot be stored!!");
                }

            case "T2":
                if (!T2.isFull()) {
                    T2.push(URL);
                    output.println("The URL (" + URL + ") was pushed into Stack T2");
                    break;
                } else {
                    output.println("The T2 stack is full, the following URL (" + URL + ") cannot be stored!!");
                }

            case "T3":
                if (!T3.isFull()) {
                    T3.push(URL);
                    output.println("The URL (" + URL + ") was pushed into Stack T3");
                    break;
                } else {
                    output.println("The T3 stack is full, the following URL (" + URL + ") cannot be stored!!");
                }

        }
    }

    //=====================================================================================\\
    public static void GO_BACK(webPageStackArray T1, webPageStackArray T2, webPageStackArray T3, webPageStackArray History, Scanner input2, PrintWriter output) {
        String tab = input2.next();
        String URL = null;
        switch (tab) {
            case "T1":
                URL = T1.pop();
                break;

            case "T2":
                URL = T2.pop();
                break;

            case "T3":
                URL = T3.pop();
                break;

        }
        if (!History.isFull()) {
            History.push(URL);
        } else {
            output.println("The history stack is full, the following URL (" + URL + ") cannot be stored!!");
        }

    }

    //=====================================================================================\\
    public static void DISPLAY_ALL_VISITED(webPageStackArray T1, webPageStackArray T2, webPageStackArray T3, webPageStackArray History, PrintWriter output) {

        output.println("The content of Stack T1:\n_________________________\n");
        T1.DISPLAY_VISITED(output);

        output.println("\n\nThe content of Stack T2:\n_________________________\n");
        T2.DISPLAY_VISITED(output);

        output.println("\n\nThe content of Stack T3:\n_________________________\n");
        T3.DISPLAY_VISITED(output);

        output.println("\n\nThe content of the history Stack:\n_________________________\n");
        History.DISPLAY_VISITED(output);
    }
}
